package de.hft.stuttgart.citydoctor2.webservice.endpoints;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONObject;
import org.json.JSONTokener;
import org.junit.Test;

public class LoginEndpointTest {

	@Test
	public void testLoginCorrectPassword() throws ClientProtocolException, IOException {
		HttpClient client = HttpClients.createMinimal();
		HttpPost post = new HttpPost("http://localhost:8080/CityDoctorWebService/rest/login");
		
		List<NameValuePair> params = new ArrayList<NameValuePair>(2);
		params.add(new BasicNameValuePair("username", "Test"));
		params.add(new BasicNameValuePair("password", "TestPassword"));
		post.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));
		
		HttpResponse response = client.execute(post);
		assertEquals(200, response.getStatusLine().getStatusCode());
		try (BufferedReader br = new BufferedReader(new InputStreamReader(response.getEntity().getContent()))) {
			JSONTokener tokener = new JSONTokener(br);
			JSONObject o = new JSONObject(tokener);
			assertNotNull(o.getString("token"));
		}
	}
	
	@Test
	public void testLoginIncorrectPassword() throws ClientProtocolException, IOException {
		HttpClient client = HttpClients.createMinimal();
		HttpPost post = new HttpPost("http://localhost:8080/CityDoctorWebService/rest/login");
		
		List<NameValuePair> params = new ArrayList<NameValuePair>(2);
		params.add(new BasicNameValuePair("username", "Test"));
		params.add(new BasicNameValuePair("password", "TestIncorrectPassword"));
		post.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));
		
		HttpResponse response = client.execute(post);
		assertEquals(403, response.getStatusLine().getStatusCode());
	}

}
